﻿--
-- Heath SuperChaser
--
-- author Mythos
-- date  20/06/2011
-- www.Virtual-Farmers.gr
-- Copyright (C) ARM Team, All Rights Reserved.

-- changes for Proag 16K: KillaBot & Wodka-Bull24
-- with permission from Mythos
-- www.HoT-HQ.de --


Heath = {};
--________________________________________________________________________________________________________________________________________________________
function Heath.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:load(savegame)

    self.firstTime = true;
	self.state = 0;
    -- Functions
    self.FiHeBa= SpecializationUtil.callSpecializationsFunction("FiHeBa");
    
    self.FiDi= SpecializationUtil.callSpecializationsFunction("FiDi");
    self.MPCode = SpecializationUtil.callSpecializationsFunction("MPCode");    
    
    -- Animations
    self.workmodeEven = getXMLString(self.xmlFile, "vehicle.workmodeEven#animationName");
    self.workmodeOdd = getXMLString(self.xmlFile, "vehicle.workmodeOdd#animationName");
    self.workmodeZero = getXMLString(self.xmlFile, "vehicle.workmodeZero#animationName");
    self.transportmodeEven = getXMLString(self.xmlFile, "vehicle.transportmodeEven#animationName");
    self.transportmodeOdd = getXMLString(self.xmlFile, "vehicle.transportmodeOdd#animationName");
    self.transportmodeFull = getXMLString(self.xmlFile, "vehicle.transportmodeFull#animationName");
    
    self.transportUnloaded = getXMLString(self.xmlFile, "vehicle.transportUnloaded#animationName");
    self.transportUnloadedFull = getXMLString(self.xmlFile, "vehicle.transportUnloadedFull#animationName");
    self.transportUnloadedEven = getXMLString(self.xmlFile, "vehicle.transportUnloadedEven#animationName");
    self.transportSlider = getXMLString(self.xmlFile, "vehicle.transportSlider#animationName");
    self.transportUnloadedA = getXMLString(self.xmlFile, "vehicle.transportUnloadedA#animationName");
    self.transportUnloadedFullA = getXMLString(self.xmlFile, "vehicle.transportUnloadedFullA#animationName");
    self.transportUnloadedEvenA = getXMLString(self.xmlFile, "vehicle.transportUnloadedEvenA#animationName");
    
    self.preparefromOdd = getXMLString(self.xmlFile, "vehicle.preparefromOdd#animationName");
    self.preparefromEven = getXMLString(self.xmlFile, "vehicle.preparefromEven#animationName");
    self.preparefromFull = getXMLString(self.xmlFile, "vehicle.preparefromFull#animationName");
    
    self.loadEven2 = getXMLString(self.xmlFile, "vehicle.loadEven2#animationName");
    self.loadEven4 = getXMLString(self.xmlFile, "vehicle.loadEven4#animationName");
    self.loadEven6 = getXMLString(self.xmlFile, "vehicle.loadEven6#animationName");
    self.loadEven8 = getXMLString(self.xmlFile, "vehicle.loadEven8#animationName");
    self.loadEven10 = getXMLString(self.xmlFile, "vehicle.loadEven10#animationName");
    self.loadEven12 = getXMLString(self.xmlFile, "vehicle.loadEven12#animationName");
    self.loadOdd = getXMLString(self.xmlFile, "vehicle.loadOdd#animationName");
    self.loadFull = getXMLString(self.xmlFile, "vehicle.loadFull#animationName");
    
    self.unload = getXMLString(self.xmlFile, "vehicle.unload#animationName");
    
    self.step1 = getXMLString(self.xmlFile, "vehicle.step1#animationName");
    self.step2 = getXMLString(self.xmlFile, "vehicle.step2#animationName");
    self.step3 = getXMLString(self.xmlFile, "vehicle.step3#animationName");
    self.step4 = getXMLString(self.xmlFile, "vehicle.step4#animationName");
    
    self.slide1 = getXMLString(self.xmlFile, "vehicle.slide1#animationName");
    self.slide2 = getXMLString(self.xmlFile, "vehicle.slide2#animationName");
    self.slide3 = getXMLString(self.xmlFile, "vehicle.slide3#animationName");
    self.slide3a = getXMLString(self.xmlFile, "vehicle.slide3a#animationName");
    self.slide4 = getXMLString(self.xmlFile, "vehicle.slide4#animationName");
    self.slide5 = getXMLString(self.xmlFile, "vehicle.slide5#animationName");
    self.slide6 = getXMLString(self.xmlFile, "vehicle.slide6#animationName");

    -- Indexs
    self.base = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.base#index"));
    self.slider = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.slider#index"));
    self.balesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#index"));
    self.ref = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.baleRef#index"));
    
    self.spikeJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#joint"));
    self.haySpike = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#hay"));
    self.strawSpike = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#straw"));
    self.strawSpikeId = nil;
    self.haySpikeEven = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#hayEven"));
    self.strawSpikeEven = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#strawEven"));
    self.strawSpikeEvenId = nil;
    
    self.linkOddBale = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.loadedBales.bale1#index"));
    self.linkEvenBale = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.loadedBales.bale2#index"));
    
    self.tim = 1000;
    -- Particles
    self.sParticles = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.sParticles.pSystem(%d)", i);
        local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.. "#index"));
        if node == nil then
            break;
        end; 
        --Utils.loadParticleSystem(self.xmlFile, self.sParticles, key, node, false, nil, self.baseDirectory)
		local currentPS = {};
		ParticleUtil.loadParticleSystem(self.xmlFile, currentPS, key, node, false, nil, self.baseDirectory);
		table.insert(self.sParticles, currentPS);
        i = i +1;        
    end;
    self.unParticles = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.hParticles.pSystem(%d)", i);
        local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.. "#index"));
        if node == nil then
            break;
        end; 
        --Utils.loadParticleSystem(self.xmlFile, self.hParticles, key, node, false, nil, self.baseDirectory)
		local currentPS = {};
		ParticleUtil.loadParticleSystem(self.xmlFile, currentPS, key, node, false, nil, self.baseDirectory);
		table.insert(self.unParticles, currentPS);
        i = i +1;        
    end;
    
    -- Bales Loaded Tables
    self.hayBales = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.hayBales.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            table.insert(self.hayBales, index);
        end;
        i = i + 1;
    end;
        
    self.strawBales = {};
    self.strawBalesId = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.strawBales.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            table.insert(self.strawBales, index);
            table.insert(self.strawBalesId, nil);
        end;
        i = i + 1;
    end;
    self.numMaxBales = i;
    
    -- Booleans
    self.i = {};
    self.workMode = false;
    self.prepareMode = false;
    self.unloadMode = false;
    self.unloaded = false;
    
    self.counter = 0;
    self.animEnded = true;
    self.foundIt = false;
    self.baleId = nil;
    self.fruitBale = " ";
    
    self.old_dif = 0;
    
    self.okai = false;
    self.okai2 = false;
    self.okai3 = false;
    self.okai4 = false;
    
    self.itsOver = false;
    self.itsOver2 = false;
    self.itsOver3 = false;
    self.endGame = false;
    self.ready2go = false;
    self.abort = false;
    self.tranprep = false;
    
    self.usedFruitType = 0;
    self.bales = {};
    
    self.setTim = false;
    
    self.fillLevel = 0;
    self.fillLevelMax = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.capacity"), 0);
    
    self.balesToLoad = {};
    self.balesToMount = {};

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:delete()
    --Utils.deleteParticleSystem(self.hParticles);
    --Utils.deleteParticleSystem(self.sParticles);
	for _, particleSystem in pairs(self.sParticles) do
        ParticleUtil.deleteParticleSystem(particleSystem)
	end;
	for _, particleSystem in pairs(self.unParticles) do
        ParticleUtil.deleteParticleSystem(particleSystem)
	end;
	
    for i, balePlace in pairs(self.strawBales) do
        if self.strawBalesId[i] ~= nil then
            local bale = networkGetObject(self.strawBalesId[i]);
            if bale ~= nil then
                bale:unmount();
                self.strawBalesId[i] = nil;
            end;
        end;
    end;
    if self.strawSpikeId ~= nil then
        local bale = networkGetObject(self.strawSpikeId);
        if bale ~= nil then
            bale:unmount();
            self.strawSpikeId = nil;
        end;
    end;
    if self.strawSpikeEvenId ~= nil then
        local bale = networkGetObject(self.strawSpikeEvenId);
        if bale ~= nil then
            bale:unmount();
            self.strawSpikeEvenId = nil;
        end;
    end;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:mouseEvent(posX, posY, isDown, isUp, button)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:keyEvent(unicode, sym, modifier, isDown)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:update(dt)
    if self.firstTime then
        self.firstTime = false;
        for k,v in pairs(self.balesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz, v.fillLevel);
            if v.parentNode ==  self.strawSpike then
                baleObject:mount(self, self.strawSpike, x,y,z, rx,ry,rz);
            elseif v.parentNode ==  self.strawSpikeEven then
                baleObject:mount(self, self.strawSpikeEven, x,y,z, rx,ry,rz);
            else
                baleObject:mount(self, self.strawBales[k], x,y,z, rx,ry,rz);
            end
            if v.baleValueScale ~= nil then
                baleObject.baleValueScale = v.baleValueScale;
            end
            if v.wrappingState ~= nil and baleObject.setWrappingState ~= nil then
                baleObject:setWrappingState(v.wrappingState);
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.balesToLoad[k] = nil;
            if v.parentNode ==  self.strawSpike then
                self.strawSpikeId = v.baleId;                
            elseif v.parentNode ==  self.strawSpikeEven then
                self.strawSpikeEvenId = v.baleId;
            else
                self.strawBalesId[k] = v.baleId;
            end
        end;
        
        for k, baleToMount in pairs(self.balesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.balesToMount[k] = nil;
            end;
        end;
    end;

if  self:getIsActive() then
    if self.animEnded then
        if self.unloadMode then
            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                self:MPCode(23, false, 0, 0, 0);
            end;
        elseif self.unloaded then
            if not self.endGame then
                
                    if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                        self.abort = true;
                        self:MPCode(20, not self.unloaded, 0, 0, 0);
                    end;
                    
                    
                    if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) and self:getIsActiveForInput() then
                        self.setTim = true;
                        self:MPCode(24, false, 0, 0, 0);
                    end;
                
            elseif self.ready2go then
                if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                    self:MPCode(20, not self.unloaded, 0, 0, 0);
                end;
            end;
        else
            if self.abort and (self.counter == 12 or self.counter == 11) then
                if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                    self:MPCode(23, false, 0, 0, 0);
                end;
            elseif self.abort and self.counter ~= 12 and self.counter ~= 11 then
                if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                    self:MPCode(20, not self.workMode, 0, 0, 0);
                end;
                if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                    self:MPCode(23, false, 0, 0, 0);
                end;
            else
                if not self.workMode and self.counter == 12 then
                    if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                        self:MPCode(23, false, 0, 0, 0);
                    end;
                else
                    if not self.workMode then
                        if self.counter == 0 then
                            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                                self:MPCode(20, not self.workMode, 0, 0, 0);
                            end;
                        else
                            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                                self:MPCode(20, not self.workMode, 0, 0, 0);
                            end;
                            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) and self:getIsActiveForInput() then
                                if self.counter == 2 or self.counter == 4 or self.counter == 6 or self.counter == 8 or self.counter == 10 or self.counter == 12 then
                                    self:MPCode(23, false, 0, 0, 0);
                                else
                                    self:MPCode(22, false, 0, 0, 0);
                                end
                            end;
                        end;
                    else
                        if self.counter == 12 then
                            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                                self:MPCode(20, not self.workMode, 0, 0, 0);
                            end;
                        else
                            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self:getIsActiveForInput() then
                                self:MPCode(20, not self.workMode, 0, 0, 0);
                            end;
                            if self.foundIt then
                                if math.mod(self.counter, 2) == 0 then
                                    if self.fruitBale:lower():find("hay") ~= nil then
                                        self.fruitBale = "hay";
                                        self.state = 2;
                                    else
                                        self.fruitBale = "straw";
                                        self.state = 2;
                                    end;
                                else
                                    if self.fruitBale:lower():find("hay") ~= nil then
                                        self.fruitBale = "hay";
                                        self.state = 4;
                                    else
                                        self.fruitBale = "straw";
                                        self.state = 4;
                                    end;
                                end;

                                self:MPCode(21, false, self.state, self.baleId, 0);
                            else
                                self:FiHeBa(self.spikeJoint);
                            end;
                        end;
                    end;
                end;
            end;
        end;
    end;
end;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:draw()

if self.animEnded then
    if self.unloadMode then
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE2"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
    elseif self.unloaded then
        if not self.endGame then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("ABORT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
        elseif self.ready2go then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
        end;
    else
        if self.abort then
            if self.state == 5 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE2"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);    
            else
                if self.counter == 2 or self.counter == 4 or self.counter == 6 or self.counter == 8 or self.counter == 10 then
                    g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
                    g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE2"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                else
                    g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                end
            end
        else
            if self.counter == 12 and not self.workMode then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE2"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
            else
                if not self.workMode then
                    if self.counter == 0 then
                        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
                    else
                        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
                        if self.counter == 2 or self.counter == 4 or self.counter == 6 or self.counter == 8 or self.counter == 10 then
                            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE2"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                        else
                            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                        end;
                    end;
                else
                    if    self.counter == 12 then
                        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
                    else
                        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
                    end;
                end;
            end;
        end;
    end;
end;
    
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:MPCode(mode, bool, state, dif, olddif, noEventSend)
    MPEvent.sendEvent(self, mode, bool, state, dif, olddif, noEventSend);
    
--______________________________________________________________________________
if mode == 20 then
--______________________________________________________________________________
    if bool then
        if math.mod(self.counter, 2) == 0 then
            if self.counter == 0 then
                self:playAnimation(self.workmodeZero, 1, nil, true);
                self.workMode = true;
                self.abort = false;
            else
                self:playAnimation(self.workmodeOdd, 1, nil, true);
                self.workMode = true;
                self.abort = false;
            end;
        else
            self:playAnimation(self.workmodeEven, 1, nil, true);
            self.workMode = true;
            self.abort = false;
        end;
    else
        if self.unloaded then
            if self.counter == 12 then
                self:playAnimation(self.transportUnloadedFullA, 1, nil, true);
                self.unloaded = false;
                self.ready2go = false;
                self.endGame = false;
                self.okai = false;
            elseif self.counter == 6 then
                self:playAnimation(self.transportUnloadedEvenA, 1, nil, true);
                self.unloaded = false;
                self.ready2go = false;
                self.endGame = false;
                self.okai = false;
            elseif self.counter == 0 then
                self:playAnimation(self.transportUnloaded, 1, nil, true);
                self.unloaded = false;
                self.ready2go = false;
                self.endGame = false;
                self.okai = false;
            else
                
                self:playAnimation(self.transportUnloadedA, 1, nil, true);
                self.unloaded = false;
                self.ready2go = false;
                self.endGame = false;
                self.okai = false;
                self.tranprep = true;
            end;        
            
        elseif math.mod(self.counter, 2) == 0 then
            if self.counter == 0 then
                self:playAnimation(self.workmodeZero, -1, nil, true);
                self.workMode = false;
                self.foundIt = false;
            elseif self.counter == 12 then
                self:playAnimation(self.transportmodeFull, 1, nil, true);
                self.workMode = false;
                self.foundIt = false;
            else
                self:playAnimation(self.transportmodeEven, 1, nil, true);
                self.workMode = false;
                self.foundIt = false;
            end;
        else
            self:playAnimation(self.transportmodeOdd, 1, nil, true);
            self.workMode = false;
            self.foundIt = false;
        end;
    end;
--______________________________________________________________________________
elseif mode == 21 then    
--______________________________________________________________________________
    self.baleId = dif;
    if self.counter == 11 then
        local object = networkGetObject(self.baleId);
        if object == nil then
            return;
        end;
        
        object:mount(self, self.strawSpikeEven, 0,0,0, 0,0,0);
        self.strawSpikeEvenId = self.baleId
        
        self:playAnimation(self.loadFull, 1, nil, true);
        self.counter = self.counter + 1;
        self.fillLevel = self.counter;
        self.foundIt = false;
    elseif math.mod(self.counter, 2) == 0 then
        local object = networkGetObject(self.baleId);
        if object == nil then
            return;
        end;
        
        object:mount(self, self.strawSpike, 0,0,0, 0,0,0);
        self.strawSpikeId = self.baleId
        
        self:playAnimation(self.loadOdd, 1, nil, true);
        self.counter = self.counter + 1;
        self.fillLevel = self.counter;
        self.foundIt = false;
    else
        local object = networkGetObject(self.baleId);
        if object == nil then
            return;
        end;
        object:mount(self, self.strawSpikeEven, 0,0,0, 0,0,0);
        self.strawSpikeEvenId = self.baleId
        
        if self.counter ==1 then
            self:playAnimation(self.loadEven2, 1, nil, true);
        elseif self.counter ==3 then
            self:playAnimation(self.loadEven4, 1, nil, true);
        elseif self.counter ==5 then
            self:playAnimation(self.loadEven6, 1, nil, true);
        elseif self.counter ==7 then
            self:playAnimation(self.loadEven8, 1, nil, true);
        elseif self.counter ==9 then
            self:playAnimation(self.loadEven10, 1, nil, true);
        elseif self.counter ==11 then
            self:playAnimation(self.loadEven12, 1, nil, true);
        end;
        self.counter = self.counter + 1;
        self.fillLevel = self.counter;
        self.foundIt = false;
    end;
--______________________________________________________________________________
elseif mode == 22 then
--______________________________________________________________________________
    if self.counter == 12 then
        self:playAnimation(self.preparefromFull, 1, nil, true);
        self.unloadMode = true;
        if self.abort == false then
            self.state = 5;
        else
            self.state = 0;
        end;
        self.abort = false;
    elseif math.mod(self.counter, 2) == 0 then
        self:playAnimation(self.preparefromEven, 1, nil, true);
        self.unloadMode = true;
        if self.abort == false then
            self.state = 5;
        else
            self.state = 0;
        end;
        self.abort = false;
    else
        self:playAnimation(self.preparefromOdd, 1, nil, true);
        self.unloadMode = true;
        if self.abort == false then
            self.state = 5;
        else
            self.state = 0;
        end;
        self.abort = false;        
    end;
--______________________________________________________________________________
elseif mode == 23 then
--______________________________________________________________________________
    self:playAnimation(self.unload, 1, nil, true);
    self.unloadMode = false;
    self.unloaded = true;
    self.foundIt = false;
--______________________________________________________________________________
elseif mode == 24 then
--______________________________________________________________________________
    
    for i,v in pairs(self.strawBalesId) do
        if self.strawBalesId[i] ~= nil then
            local object = networkGetObject(v);
            if object ~= nil then
                object:unmount()
            end;
            self.strawBalesId[i] = nil;
        end;
    end;

    self.counter = 0;
    
    local limit = 1;
    for index, item in pairs(g_currentMission.itemsToSave) do
        if item.item:isa(Bale) then
            local refx, refy, refz = getWorldTranslation(self.ref);
            local bx, by, bz = getWorldTranslation(item.item.nodeId);
            self.distance = Utils.vector3Length(refx-bx, refy-by, refz-bz);
            if self.distance < limit then
                self.baleId2 = item.item.nodeId;
                break;
            end;
        else
            self.baleId2 = nil;
        end;
    end;
    
    self.fillLevel = 0;
    
    self.endGame = true;
    self.abort = false;
    self.state = 5;
    if self.tranprep then
        self.tranprep = false;
    end;
	for _, ps in pairs(self.unParticles) do
		ParticleUtil.setEmittingState(ps, true);
	end;
--______________________________________________________________________________
elseif mode == 25 then
--______________________________________________________________________________
    if state==2 then
        local i = self.counter;
        self.savestate = state;
    elseif state==4 and self.strawSpikeEvenId ~= nil then
        local object = networkGetObject(self.strawSpikeEvenId);
        if object == nil then
            return;
        end;
        object:unmount()
        object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
        self.strawBalesId[self.counter] = self.strawSpikeEvenId;
        self.strawSpikeEvenId = nil;
        local i = self.counter;
        if self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            if object == nil then
                return;
            end;
            object:unmount()
            object:mount(self, self.strawBales[self.counter-1], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter-1] = self.strawSpikeId;
            self.strawSpikeId = nil;
        end
    end;
    self.itsOver = true;
--______________________________________________________________________________
elseif mode == 26 then
--______________________________________________________________________________

--______________________________________________________________________________
elseif state==5 then
    if self.counter ==1 then
        self:playAnimation(self.slide1, 1, nil, true);
    elseif self.counter ==3 or self.counter ==3 then
        self:playAnimation(self.slide2, 1, nil, true);
    elseif self.counter ==5 or self.counter ==5 then
        self:playAnimation(self.slide3, 1, nil, true);
    elseif self.counter ==7 or self.counter ==7 then
        self:playAnimation(self.slide4, 1, nil, true);
        elseif self.counter ==9 or self.counter ==9 then
        self:playAnimation(self.slide5, 1, nil, true);
    elseif self.counter ==11 or self.counter ==11 then
        self:playAnimation(self.slide6, 1, nil, true);
    end;
elseif state==6 then
    self.setTim = false;
	for _, ps in pairs(self.unParticles) do
		ParticleUtil.setEmittingState(ps, false);
	end;
    self.tim = 1000;
elseif state==7 then
    self:playAnimation(self.transportSlider, 1, nil, true);
    self.old_dif = 0;
    self.ready2go = true;
elseif state==8 then
    translate(self.slider, 0, 0, -(dif-olddif));
    self.old_dif = dif;
end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:updateTick(dt)
if self:getIsActive() then

    if self.endGame and not self.okai and self.baleId2 ~= nil then
            self.okai = true;
    elseif self.endGame and not self.okai and self.baleId2 == nil then
        self.okai = true;
    end;

    self.old_dif = 0;
    self.ready2go = true;
    
    for name,v in pairs(self.animations) do
        if self.activeAnimations[name] ~= nil then
            self.animEnded = false;
            self.animName = name;
            break;
        else
            self.animEnded = true;
            self.animName = nil;
            self.itsOver = false;
            self.itsOver2 = false;
            self.itsOver3 = false;
        end;
    end;
    
    if self.setTim then
        self.tim = self.tim - dt;
        if self.tim <0 then
            self.state = 6;
            self:MPCode(0, false, self.state, 0, 0);
        end;
    end;
    

    if self.animName ~= nil and self.animName == "WorkModeOdd" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 2500 then
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "WorkModeOdd" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3100 then
            self.okai2 = false;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "WorkModeEven" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3000 then
			for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "WorkModeEven" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3950 then
			for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;

    if not self.tranprep then
        if self.animName ~= nil and self.animName == "PrepareModeEven" and not self.okai2 then
            self.animTime = self:getRealAnimationTime(self.animName);
            if self.animTime > 0 then
                self.okai2 = true;
            end;
        end;
        
        if self.animName ~= nil and self.animName == "PrepareModeEven" and self.okai2 then
            self.animTime = self:getRealAnimationTime(self.animName);
            if self.animTime > 600 then
                self.okai2 = false;
            end;
        end;
    end;
    
    if self.tranprep == false or (self.tranprep and self.counter == 11) then
        if self.animName ~= nil and self.animName == "PrepareModeOdd" and not self.okai2 then
            self.animTime = self:getRealAnimationTime(self.animName);
            if self.animTime > 0 then
                self.okai2 = true;
            end;
        end;
            
        if self.animName ~= nil and self.animName == "PrepareModeOdd" and self.okai2 then
            self.animTime = self:getRealAnimationTime(self.animName);
            if self.animTime > 600 then
                self.okai2 = false;
            end;
        end;        
    end;
    
    if self.animName ~= nil and self.animName == "PrepareModeFull" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 0 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "PrepareModeFull" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 600 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;

    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 0 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 2500 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;
    
    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 2600 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3000 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;
    
------------------------    
    if self.animName ~= nil and (self.animName == "Slide1" or self.animName == "Slide2" or self.animName == "Slide3" or self.animName == "Slide4" or self.animName == "Slide5" or self.animName == "Slide6") and not self.okai4 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime >= 2000 and self.animName == self.slide1 and self.strawSpikeId ~= nil then
            self.okai4 = true;
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        elseif self.animTime >= 1500 and self.animName == self.slide2 and self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        elseif self.animTime >= 1000 and self.animName == self.slide3 and self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        elseif self.animTime >= 1000 and self.animName == self.slide4 and self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        elseif self.animTime >= 1000 and self.animName == self.slide5 and self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        elseif self.animTime >= 1000 and self.animName == self.slide6 and self.strawSpikeId ~= nil then
            local object = networkGetObject(self.strawSpikeId);
            object:unmount()
            object:mount(self, self.strawBales[self.counter], 0,0,0, 0,0,0);
            self.strawBalesId[self.counter] = self.strawSpikeId;
            self.strawSpikeId = nil;
        end;
    end;
    if self.animName ~= nil and (self.animName == "Slide1" or self.animName == "Slide2" or self.animName == "Slide3" or self.animName == "Slide4" or self.animName == "Slide5" or self.animName == "Slide6") and self.okai4 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime < 2000 then
            self.okai4 = false;
        end;
    end;

    if self.animName ~= nil and self.animName == "TransportOdd" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 0 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "TransportOdd" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 1000 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "LoadModeOdd" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 0 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "LoadModeOdd" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 200 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;

    if self.animName ~= nil and self.animName == "LoadModeOdd" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 225 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "LoadModeOdd" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 249 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "LoadModeFull" and not self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 0 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, true);
			end;
            self.okai2 = true;
        end;
    end;
    
    if self.animName ~= nil and self.animName == "LoadModeFull" and self.okai2 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3000 then
            for _, ps in pairs(self.sParticles) do
				ParticleUtil.setEmittingState(ps, false);
			end;
            self.okai2 = false;
        end;
    end;

    if self.animName == self.loadOdd and not self.itsOver then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 50 then
            self:MPCode(25, false, self.state, 0, 0);
        end;
    end;
        
    if self.animName == self.loadFull and not self.itsOver then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 3000 then
            self:MPCode(25, false, self.state, 0, 0);
        end;
    end;
        
    if self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime > 2500 and not self.itsOver then
            
        end;
    end;
        
    if not self.itsOver3 and (self.animName == self.preparefromOdd) then
        self.animTime = self:getAnimationTime(self.animName);
        if self.animTime >0.3 then
            self:MPCode(0, false, self.state, 0, 0);
        end;
    end;

    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and not self.okai3 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime >= 4000 and self.animName == self.loadEven2 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        elseif self.animTime >= 3500 and self.animName == self.loadEven4 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        elseif self.animTime >= 3000 and self.animName == self.loadEven6 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        elseif self.animTime >= 3000 and self.animName == self.loadEven8 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        elseif self.animTime >= 3000 and self.animName == self.loadEven10 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        elseif self.animTime >= 3000 and self.animName == self.loadEven12 then
            self:MPCode(25, false, self.state, 0, 0);
            self.okai3 = true;
        end;        
    end;
    if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 or self.animName == self.loadEven10 or self.animName == self.loadEven12) and self.okai3 then
        self.animTime = self:getRealAnimationTime(self.animName);
        if self.animTime < 4000 then
            self.okai3 = false;
        end;
    end;
    
    
    --for i, v in pairs(self.componentJoints) do
      --  setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
    --end;
    
end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiDi(node,noEventSend)
    local x,y,z = localDirectionToWorld(node, 0, 0, 1);
    local length = Utils.vector2Length(x,z);
    local dX = x/length;
    local dZ = z/length;
    local JointDir = math.deg(math.atan2(dX,dZ)); 
    if JointDir < 0 then
        JointDir = 360 - (JointDir * -1);
    end;
    self.objDir = JointDir;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiHeBa(LoadJoint,noEventSend)
    
    local px, py, pz = getWorldTranslation(LoadJoint);
    local nearestDistance = 1;
    local nearestBale = nil;
    
    for index, item in pairs(g_currentMission.itemsToSave) do
		local isRoundbale = Utils.getNoNil(getUserAttribute(item.item.nodeId, "isRoundbale"), false);
		local isHDbale = Utils.getNoNil(getUserAttribute(item.item.nodeId, "isHDbale"), false);
		if not isHDbale then
			isHDbale = (Utils.getNoNil(getUserAttribute(item.item.nodeId, "size"), 0) == 493612);
		end
		local isBigBale = Utils.getNoNil(getUserAttribute(item.item.nodeId, "isBigBale"), false);
		if not isBigBale then
			isBigBale = (Utils.getNoNil(getUserAttribute(item.item.nodeId, "size"), 0) == 121324);
		end
        if item.item:isa(Bale) and not isRoundbale and not isHDbale and not isBigBale then
            local bx, by, bz = getWorldTranslation(item.item.nodeId);
            local distance = Utils.vector3Length(px-bx, py-by, pz-bz);
            if distance < nearestDistance then
                self.baleId = item.item.nodeId;
                self:FiDi(self.baleId);
                self.baleDir = self.objDir;
                self:FiDi(LoadJoint);
                self.spikeDir = self.objDir;
                self.dif = self.spikeDir - self.baleDir;
                if math.abs(self.dif) <=45 or (180-math.abs(self.dif)) <=45 then
                    self.foundIt = true;
                    self.baleId = networkGetObjectId(item.item);
                    self.fruitBale = getName(item.item.nodeId);
                else
                    self.foundIt = false;
                    self.baleId = nil;
                    self.fruitBale = " ";
                end;
            end;
            if self.foundIt then
                break;
            end;
        end;
    end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:postLoad(savegame)
	if savegame == nil then
		return
	end

		
    if not savegame.resetVehicles then
		local key = savegame.key;
        self.counter = Utils.getNoNil(getXMLInt(savegame.xmlFile, key.."#numBales"),0);
    
        local i=0;
        while true do
            local baleKey = key..string.format(".bale(%d)", i);
            if not hasXMLProperty(savegame.xmlFile, baleKey) then
                break;
            end;

            local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
            if filename ~= nil then
                filename = Utils.convertFromNetworkFilename(filename);
                local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
                local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
                local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
                local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
                local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
                if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                    print("Warning: Corrupt savegame, bale "..filename.." could not be loaded");
                else
                    local translation;
                    local rotation;
                    if balePlace > 0 then
                        translation = {x,y,z};
                        rotation={xRot, yRot, zRot};
                    else
                        translation = {0,0,0};
                        rotation={0,0,0};
                    end;
                    local parentNode = nil;
                    local bales = nil;
                    if balePlace < 1 then
                        
                    elseif balePlace <= table.getn(self.strawBales) then
                        parentNode = self.strawBales[balePlace];
                        bales = self.strawBalesId[balePlace];
                    elseif balePlace == 13 then
                        parentNode = self.strawSpike;
                        bales = self.strawSpikeId;
                    elseif balePlace == 14 then
                        parentNode = self.strawSpikeEven;
                        bales = self.strawSpikeEvenId;
                    end;
                    if parentNode ~= nil then
                        local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                        local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                        table.insert(self.balesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                    end;
                end;
            end;
            i = i +1;
        end;
    
        self.fillLevel = self.counter;
    else
        self.counter = 0;
        self.fillLevel = 0;
    end;
    return BaseMission.VEHICLE_LOAD_OK;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'numBales="'..tostring(self.counter)..'"';
    
    local nodes = "";
    local baleCounter = 0;
    
    local baleNum = 0;
    
    for i, balePlace in pairs(self.strawBales) do
        if self.strawBalesId[i] ~= nil then
            local bale = networkGetObject(self.strawBalesId[i]);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<bale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
    if self.strawSpikeId ~= nil then
        local bale = networkGetObject(self.strawSpikeId);
        if bale ~= nil then
            local nodeId = bale.nodeId;
            local x,y,z = getTranslation(nodeId);
            local rx,ry,rz = getRotation(nodeId);
            if baleNum>0 then
                nodes = nodes.."\n";
            end;
            local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
            local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
            nodes = nodes..nodeIdent..'<bale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'.. 13 ..'" />';
            baleNum = baleNum+1;
        end;
    end;
    if self.strawSpikeEvenId ~= nil then
        local bale = networkGetObject(self.strawSpikeEvenId);
        if bale ~= nil then
            local nodeId = bale.nodeId;
            local x,y,z = getTranslation(nodeId);
            local rx,ry,rz = getRotation(nodeId);
            if baleNum>0 then
                nodes = nodes.."\n";
            end;
            local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
            local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
            nodes = nodes..nodeIdent..'<bale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'.. 14 ..'" />';
            baleNum = baleNum+1;
        end;
    end;
    -----
    
    return attributes,nodes;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:readStream(streamId, connection)

    self.animEnded = streamReadBool(streamId);
    self.unloadMode = streamReadBool(streamId);
    self.unloaded = streamReadBool(streamId);
    self.abort = streamReadBool(streamId);
    self.workMode = streamReadBool(streamId);
    self.endGame = streamReadBool(streamId);
    self.ready2go = streamReadBool(streamId);
    self.prepareMode = streamReadBool(streamId);
    
    self.okai = streamReadBool(streamId);
    self.okai2 = streamReadBool(streamId);
    self.okai3 = streamReadBool(streamId);
    self.okai4 = streamReadBool(streamId);
    
    self.itsOver = streamReadBool(streamId);
    self.itsOver2 = streamReadBool(streamId);
    self.itsOver3 = streamReadBool(streamId);
    self.tranprep = streamReadBool(streamId);
    self.counter = streamReadInt32(streamId);
    
    self.animName = streamReadString(streamId);
    self.animTime = streamReadFloat32(streamId);
    self.fruitBale = streamReadString(streamId);
    
    for i=1, table.getn(self.hayBales) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.strawBalesId[i] = baleServerId;
		if baleServerId ~= nil then
			self.balesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.strawBales[i], trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    local baleServerId = streamReadFloat32(streamId);
	if baleServerId == 4711 then
		baleServerId = nil;
	end
    self.strawSpikeId = baleServerId;
	if baleServerId ~= nil then
		self.balesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.strawSpike, trans={ 0,0,0}, rot={0,0,0} };
	end
    local baleServerId = streamReadFloat32(streamId);
	if baleServerId == 4711 then
		baleServerId = nil;
	end
    self.strawSpikeEvenId = baleServerId;
    if baleServerId ~= nil then
		self.balesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.strawSpikeEven, trans={ 0,0,0}, rot={0,0,0} };
    end
    if math.mod(self.counter, 2) == 0 and self.counter ~= 12 and self.counter ~= 0 then
        self:playAnimation(self.loadEven, 1, nil, true);
        AnimatedVehicle.updateAnimations(self, 99999999);
    elseif self.counter == 12 then
        self:playAnimation(self.loadFull, 1, nil, true);
        AnimatedVehicle.updateAnimations(self, 99999999);
    end;

    for name,v in pairs(self.animations) do
        if self.activeAnimations[name] ~= nil then
            self:playAnimation(name, 1, nil, true);
            AnimatedVehicle.updateAnimations(self, 99999999);
        end;
    end;
    
    if self.workMode then
        self:playAnimation(self.workmodeZero, 1, nil, true);
    end
    if self.unloaded then
        self:playAnimation(self.unload, 1, nil, true);
    end
    self.fillLevel = streamReadFloat32(streamId);
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:writeStream(streamId, connection)

    streamWriteBool(streamId, self.animEnded);
    streamWriteBool(streamId, self.unloadMode);
    streamWriteBool(streamId, self.unloaded);
    streamWriteBool(streamId, self.abort);
    streamWriteBool(streamId, self.workMode);
    streamWriteBool(streamId, self.endGame);
    streamWriteBool(streamId, self.ready2go);
    streamWriteBool(streamId, self.prepareMode);

    streamWriteBool(streamId, self.okai);
    streamWriteBool(streamId, self.okai2);
    streamWriteBool(streamId, self.okai3);
    streamWriteBool(streamId, self.okai4);
    
    streamWriteBool(streamId, self.itsOver);
    streamWriteBool(streamId, self.itsOver2);
    streamWriteBool(streamId, self.itsOver3);
    streamWriteBool(streamId, self.tranprep);
    streamWriteInt32(streamId, self.counter);
    
    if self.animName == nil then
        streamWriteString(streamId, " ");
    else
        streamWriteString(streamId, self.animName);
    end
	if self.animTime == nil then
		streamWriteFloat32(streamId, 0);
	else
		streamWriteFloat32(streamId, self.animTime);
	end
	if self.fruitBale == nil then
        streamWriteString(streamId, " ");
    else
        streamWriteString(streamId, self.fruitBale);
    end

    for i=1, table.getn(self.strawBales) do
        local baleServerId = self.strawBalesId[i];
		if baleServerId == nil then
			baleServerId = 4711;
		end
        streamWriteFloat32(streamId, baleServerId);
    end;
    local baleServerId = self.strawSpikeId;
	if baleServerId == nil then
		baleServerId = 4711;
	end
    streamWriteFloat32(streamId, baleServerId);
    local baleServerId = self.strawSpikeevenId;
	if baleServerId == nil then
		baleServerId = 4711;
	end
    streamWriteFloat32(streamId, baleServerId);
        
    streamWriteFloat32(streamId, self.fillLevel);
end;